FUNCTION SGN,A,B
;
; A simpe sign function, returning the value of A times the sign of B
;
  SignB = 2*(B GE 0) - 1
  return, A*SignB
END

FUNCTION ZBRENT1,FUN,X1,X2,TOL,NITER
;+
; NOTE: This version of the NR ZBRENT procedure is derived from the
;       the Fortran-77 version, and differs (at least in the calling
;       sequence) from the ZBRENT that is part of IDLs library
;-
      ITMAX=200 & EPS=3.E-8
      A=X1
      B=X2
      FA=CALL_FUNCTION(FUN,A)
      FB=CALL_FUNCTION(FUN,B)
      IF FB*FA GT 0.  THEN BEGIN
	print,'root must be bracketed, a,b,f(a),f(b)=',a,b,fa,fb
	return,x1
      END
      FC=FB
      FOR ITER=1,ITMAX DO BEGIN
        IF FB*FC GT 0  THEN BEGIN
          C=A
          FC=FA
          D=B-A
          E=D
        END
        IF ABS(FC) LT ABS(FB) THEN BEGIN
          A=B
          B=C
          C=A
          FA=FB
          FB=FC
          FC=FA
        END
        TOL1=2.*EPS*ABS(B)+0.5*TOL
        XM=.5*(C-B)
        IF ABS(XM) LE TOL1  OR  FB EQ 0 THEN BEGIN
	  NITER=ITER
          RETURN,B
        END
        IF ABS(E) GE TOL1  AND  ABS(FA) GT ABS(FB) THEN BEGIN
          S=FB/FA
          IF A EQ C THEN BEGIN
            P=2.*XM*S
            Q=1.-S
          END ELSE BEGIN
            Q=FA/FC
            R=FB/FC
            P=S*(2.*XM*Q*(Q-R)-(B-A)*(R-1.))
            Q=(Q-1.)*(R-1.)*(S-1.)
          END
          IF P GT 0 THEN Q=-Q
          P=ABS(P)
          IF 2.*P  LT  MIN([3.*XM*Q-ABS(TOL1*Q),ABS(E*Q)]) THEN BEGIN
            E=D
            D=P/Q
          END ELSE BEGIN
            D=XM
            E=D
          END
        END ELSE BEGIN
          D=XM
          E=D
        END
        A=B
        FA=FB
        IF ABS(D)  GT  TOL1 THEN BEGIN
          B=B+D
        END ELSE BEGIN
          B=B+SGN(TOL1,XM)
        END
        FB=CALL_FUNCTION(FUN,B)
      END      
      print,'ZBRENT exceeding maximum iterations.'
      NITER=ITER
      RETURN,B
END
