(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[      4388,        167]
NotebookOptionsPosition[      3487,        133]
NotebookOutlinePosition[      3928,        150]
CellTagsIndexPosition[      3885,        147]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["4th order polynomials", "Title",
 TextAlignment->Center],

Cell[CellGroupData[{

Cell["\<\
Solve the generic 4th order equation, rather than the specific one (WHY?)\
\>", "Section"],

Cell[BoxData[
 RowBox[{"n", "=", 
  RowBox[{"Ne", " ", 
   RowBox[{"(", 
    RowBox[{"1", "+", 
     FractionBox[
      RowBox[{"1", "+", "AHe", "+", "AFe"}], 
      RowBox[{
       FractionBox["1", 
        RowBox[{"1", "+", 
         RowBox[{"KH", " ", "Ne"}]}]], "+", 
       FractionBox["AHe", 
        RowBox[{"1", "+", 
         RowBox[{"KHe", " ", "Ne"}]}]], "+", 
       FractionBox["AFe", 
        RowBox[{"1", "+", 
         RowBox[{"KFe", " ", "Ne"}]}]]}]]}], ")"}]}]}]], "Input",
 PageWidth->Infinity,
 ShowSpecialCharacters->False,
 FontSize->14],

Cell[BoxData[
 RowBox[{"nf", " ", "=", " ", 
  RowBox[{"Factor", "[", "n", "]"}]}]], "Input",
 PageWidth->Infinity,
 ShowSpecialCharacters->False,
 FontSize->14],

Cell[BoxData[
 RowBox[{"nu", " ", "=", " ", 
  RowBox[{"Numerator", "[", "nf", "]"}]}]], "Input",
 PageWidth->Infinity,
 ShowSpecialCharacters->False,
 FontSize->14],

Cell[BoxData[
 RowBox[{"de", " ", "=", " ", 
  RowBox[{"Denominator", "[", "nf", "]"}]}]], "Input",
 PageWidth->Infinity,
 ShowSpecialCharacters->False,
 FontSize->14],

Cell[BoxData[
 RowBox[{"nr", " ", "=", " ", 
  RowBox[{
   RowBox[{"nn", " ", "de"}], " ", "-", " ", "nu"}]}]], "Input",
 PageWidth->Infinity,
 ShowSpecialCharacters->False,
 FontSize->14],

Cell[BoxData[
 RowBox[{"nc", " ", "=", " ", 
  RowBox[{"Collect", "[", 
   RowBox[{"nr", ",", "Ne"}], "]"}]}]], "Input",
 PageWidth->Infinity,
 ShowSpecialCharacters->False,
 FontSize->14]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Solve the generic 4th order equation, rather than the specific one (WHY?)\
\>", "Section"],

Cell[BoxData[
 RowBox[{"Solve", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"a", " ", 
      SuperscriptBox["x", "4"]}], "+", 
     RowBox[{"b", " ", 
      SuperscriptBox["x", "3"]}], "+", 
     RowBox[{"c", " ", 
      SuperscriptBox["x", "2"]}], "+", 
     RowBox[{"d", " ", "x"}], "+", "e"}], "==", "0"}], ",", "x"}], 
  "]"}]], "Input",
 PageWidth->Infinity,
 ShowSpecialCharacters->False,
 FontSize->14],

Cell[CellGroupData[{

Cell[TextData[StyleBox["Discussion", "Subsection"]], "Subsubsection",
 CellChangeTimes->{{3.4494937254368753`*^9, 3.4494937326868753`*^9}}],

Cell["\<\
We get four roots, and it is not immediately clear which one to use.  It is \
also in practice nearly impossible to evaluate possible issues with numerical \
accuracy that could be there, if this expression was turned into a Fortran \
program.

The most devastating aspect of using this approach is that it only works as \
long as no more elements are added, so it is not a generally useful method.\
\>", "Text",
 CellChangeTimes->{{3.4494937382025003`*^9, 3.4494939143587503`*^9}, 
   3.4812572949202633`*^9}]
}, Open  ]]
}, Open  ]]
}, Open  ]]
},
AutoGeneratedPackage->None,
WindowSize->{1139, 896},
WindowMargins->{{23, Automatic}, {Automatic, 24}},
FrontEndVersion->"7.0 for Linux x86 (64-bit) (February 25, 2009)",
StyleDefinitions->FrontEnd`FileName[{"Report"}, "StandardReport.nb", 
  CharacterEncoding -> "iso8859-1"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[567, 22, 62, 1, 83, "Title"],
Cell[CellGroupData[{
Cell[654, 27, 100, 2, 75, "Section"],
Cell[757, 31, 559, 19, 71, "Input"],
Cell[1319, 52, 161, 5, 43, "Input"],
Cell[1483, 59, 165, 5, 43, "Input"],
Cell[1651, 66, 167, 5, 43, "Input"],
Cell[1821, 73, 188, 6, 43, "Input"],
Cell[2012, 81, 188, 6, 43, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2237, 92, 100, 2, 75, "Section"],
Cell[2340, 96, 420, 15, 43, "Input"],
Cell[CellGroupData[{
Cell[2785, 115, 139, 1, 27, "Subsubsection"],
Cell[2927, 118, 520, 10, 91, "Text"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
